/*--
call sp_current_stock('opening',2,'2022-04-05')
call sp_current_stock('drum',2,'2022-04-05')
call sp_current_stock('purchase',2,'2022-04-05')
call sp_current_stock('storage')
call sp_current_stock('full')*/

DROP PROCEDURE IF EXISTS sp_current_stock;
DELIMITER $$
CREATE PROCEDURE sp_current_stock(
	in vreport_type varchar(100),
	in vproduct_id int,
	in vproduction_date VARCHAR(100)
	)
BEGIN
	IF vreport_type='full' THEN
		SELECT id,
			   product_name,
			   opening,
			   purchase,
			   drum,
			   tank,
			   Sum(qty) AS quantity
		FROM   (
			SELECT vw_stock_movement.product_name,
					   int_target_opening_id  As id,
					   'Opening'              AS opening,
					   ' '                    AS purchase,
					   ' '     	           	  AS drum,
					   ' '		              AS tank,
					   vw_stock_movement.dec_quantity AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date)
						AND ( int_target_opening_id >0)
						AND ( int_product_id = vproduct_id)
					  )
			UNION ALL		
				SELECT vw_stock_movement.product_name,
				       int_source_opening_id  As id,
					   'Opening'              AS opening,
					   ' '                    AS purchase,
					   ' '     	           	  AS drum,
					   ' '		              AS tank,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date)                
						AND ( int_source_opening_id >0)
						AND ( int_product_id = vproduct_id)
					  )
			)AS qry
		GROUP  BY id,product_name,
				  opening,
				  purchase,
				  drum,
				  tank
		HAVING ( Sum(qty) > 0 )
		UNION ALL
		SELECT id,product_name,
			   opening,
			   purchase,
			   drum,
			   tank,
			   Sum(qty) AS quantity
		FROM   (
				SELECT vw_stock_movement.product_name,
					   int_target_purchase_id           As id,
					   ' '                                             AS opening,
						 vw_stock_movement.tar_purc_no  AS purchase,
					   ' '                                             AS drum,
					   ' '                                             AS tank,
					   vw_stock_movement.dec_quantity       AS qty
				FROM   (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date)
						AND ( vw_stock_movement.int_target_purchase_id>0)
						AND ( int_product_id = vproduct_id)
						  )
				UNION ALL		
				SELECT vw_stock_movement.product_name,
					   int_source_purchase_id   As id,
					   ' '                                             AS opening,
					   vw_stock_movement.src_purc_no                   AS purchase,
					   ' '                                             AS drum,
					   ' '                                             AS tank,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date)
						AND ( vw_stock_movement.int_source_purchase_id > 0 )
						AND ( int_product_id = vproduct_id)
					  )
				)AS qry
		GROUP  BY id,product_name,
				  opening,
				  purchase,
				  drum,
				  tank
		HAVING ( Sum(qty) > 0 )
		UNION ALL
		SELECT id,product_name,
			   opening,
			   purchase,
			   drum,
			   tank,
			   Sum(qty) AS quantity
		FROM   (
			SELECT vw_stock_movement.product_name,
					   int_stock_movement_id      As id,
					   ' '                        AS opening,
					   ' '                        AS purchase,
					   tar_drum_tag            	  AS drum,
					   ' '                        AS tank,
					   vw_stock_movement.dec_quantity AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( tar_drum_tag is Not NULL )
						AND ( int_product_id = vproduct_id)
					  )
			UNION ALL		
				SELECT vw_stock_movement.product_name,
					   int_stock_movement_id      As id,
					   ' '                        AS opening,
					   ' '                        AS purchase,
					   src_drum_tag            	  AS drum,
					   ' '                        AS tank,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( vw_stock_movement.src_drum_tag is NOT NULL )
						AND ( int_product_id = vproduct_id)
					  )
			)AS qry
		GROUP  BY id,product_name,
				  opening,
				  purchase,
				  drum,
				  tank
		HAVING ( Sum(qty) > 0 )
		UNION ALL
		SELECT id,product_name,
			   opening,
			   purchase,
			   drum,
			   tank,
			   Sum(qty) AS quantity
		FROM   (
			SELECT vw_stock_movement.product_name,
			           int_target_storage_unit_id As id,
					   ' '                        AS opening,
					   ' '                        AS purchase,
					   ' '     	            	  AS drum,
					   tar_storage                AS tank,
					   vw_stock_movement.dec_quantity AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( tar_storage is Not NULL )
						AND ( int_target_storage_unit_id >0)
						AND ( int_product_id = vproduct_id)
					  )
			UNION ALL		
				SELECT vw_stock_movement.product_name,
				       int_source_storage_unit_id As id,
					   ' '                        AS opening,
					   ' '                        AS purchase,
					   ' '     	            	  AS drum,
					   src_storage                AS tank,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( vw_stock_movement.src_storage is NOT NULL )
						AND ( int_source_storage_unit_id >0)
						AND ( int_product_id = vproduct_id)
					  )
			)AS qry
		GROUP  BY id,product_name,
				  opening,
				  purchase,
				  drum,
				  tank
		HAVING ( Sum(qty) > 0 );
	ELSEIF vreport_type='opening' THEN 
		SELECT product_name,
			   txt_name,
			   id,
			   Sum(qty) AS quantity
		FROM   (
			SELECT vw_stock_movement.product_name,
					   'Opening'              AS txt_name,
					   int_target_opening_id  As id,
					   vw_stock_movement.dec_quantity AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( int_target_opening_id >0)
						AND ( int_product_id = vproduct_id)
					  )
			UNION ALL		
				SELECT vw_stock_movement.product_name,
					   'Opening'              AS txt_name,
					   int_source_opening_id  As id,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date)                
						AND ( int_source_opening_id >0)
						AND ( int_product_id = vproduct_id)
					  )
			)AS qry
		GROUP  BY product_name,
				  txt_name,id
		HAVING ( Sum(qty) > 0 );
	ELSEIF vreport_type='production' THEN 
		SELECT product_name,
			   txt_name,
			   id,
			   Sum(qty) AS quantity
		FROM   (
			SELECT vw_stock_movement.product_name,
					   'production'              AS txt_name,
					   int_target_production_id  As id,
					   vw_stock_movement.dec_quantity AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( int_target_production_id >0)
						AND ( int_product_id = vproduct_id)
					  )
			UNION ALL		
				SELECT vw_stock_movement.product_name,
					   'production'              AS txt_name,
					   int_source_production_id  As id,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date)                
						AND ( int_source_production_id >0)
						AND ( int_product_id = vproduct_id)
					  )
			)AS qry
		GROUP  BY product_name,
				  txt_name,id
		HAVING ( Sum(qty) > 0 );
	ELSEIF vreport_type='purchase' THEN 
		SELECT id,product_name,
			   txt_name,
			   Sum(qty) AS quantity
		FROM   (
				SELECT vw_stock_movement.product_name,
					   int_target_purchase_id           As id,
						 vw_stock_movement.tar_purc_no  AS txt_name,
					   vw_stock_movement.dec_quantity       AS qty
				FROM   (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date)
						AND ( vw_stock_movement.int_target_purchase_id>0)
						AND ( int_product_id = vproduct_id)
						  )
				UNION ALL		
				SELECT vw_stock_movement.product_name,
					   int_source_purchase_id   As id,
					   vw_stock_movement.src_purc_no                   AS txt_name,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( vw_stock_movement.int_source_purchase_id > 0 )
						AND ( int_product_id = vproduct_id)
					)
				
				)AS qry
		GROUP  BY id,product_name,
				  txt_name
		HAVING ( Sum(qty) > 0 );
	ELSEIF vreport_type='drum' THEN
		SELECT id,product_name,
			   txt_name,
			   Sum(qty) AS quantity
		FROM   (
			SELECT vw_stock_movement.product_name,
					   int_stock_movement_id      As id,
					   tar_drum_tag            	  AS txt_name,
					   vw_stock_movement.dec_quantity AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( tar_drum_tag is Not NULL )
						AND ( int_product_id = vproduct_id)						
					  )
			UNION ALL		
				SELECT vw_stock_movement.product_name,
					   int_stock_movement_id      As id,
					   src_drum_tag            	  AS txt_name,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( vw_stock_movement.src_drum_tag is NOT NULL )
						AND ( int_product_id = vproduct_id)						
					  )
			)AS qry
		GROUP  BY id,product_name,
				  txt_name
		HAVING ( Sum(qty) > 0 );
	ELSEIF vreport_type='storage' THEN
		SELECT id,product_name,
			   txt_name,
			   Sum(qty) AS quantity
		FROM   (
			SELECT vw_stock_movement.product_name,
			           int_target_storage_unit_id As id,
					   tar_storage                AS txt_name,
					   vw_stock_movement.dec_quantity AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( tar_storage is Not NULL )
						AND ( int_target_storage_unit_id >0)
						AND ( int_product_id = vproduct_id)						
					  )
			UNION ALL		
				SELECT vw_stock_movement.product_name,
				       int_source_storage_unit_id As id,
					   src_storage                AS txt_name,
					   ( vw_stock_movement.dec_quantity *-1 )          AS qty
				FROM  (vw_stock_movement)
				WHERE ( ( dat_transaction <=vproduction_date )
						AND ( vw_stock_movement.src_storage is NOT NULL )
						AND ( int_source_storage_unit_id >0)
						AND ( int_product_id = vproduct_id)						
					  )
			)AS qry
		GROUP  BY id,product_name,
				  txt_name
		HAVING ( Sum(qty) > 0 );
	END IF;
END$$
DELIMITER ;