/*Call sp_insert_parties('Pyare','P','Mohan', Null, Null, Null,Null,Null,Null,Null,1, @return);*/

DROP PROCEDURE IF EXISTS sp_insert_parties;
DELIMITER $$
CREATE PROCEDURE sp_insert_parties(
	in vtxt_name varchar(100),
	in vtxt_short_name varchar(25),
	in vtxt_contact_person varchar(60),
	in vtxt_address varchar(200),
	in vtxt_city varchar(25),
	in vtxt_mobile varchar(25),
	in vtxt_mobile_whatsapp varchar(25),
	in vtxt_email varchar(100),
	in vtxt_gstn varchar(50),
	in vtxt_pan varchar(25),
	in vint_by_user_id int(11),
	out vintReturn INT)
BEGIN
	DECLARE int_next_id int;
	DECLARE int_fy int;
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	START TRANSACTION;
	SELECT (ifnull(MAX(int_party_id),0)+1) into int_next_id FROM tbl_parties;
	INSERT INTO tbl_parties(
	int_party_id, txt_name, txt_short_name, txt_contact_person, txt_address, txt_city, txt_mobile, txt_mobile_whatsapp, txt_email, txt_gstn, txt_pan, int_by_user_id, dat_created, dat_modified)
	 VALUES (
	int_next_id, vtxt_name, vtxt_short_name, vtxt_contact_person, vtxt_address, vtxt_city, vtxt_mobile, vtxt_mobile_whatsapp, vtxt_email, vtxt_gstn, vtxt_pan, vint_by_user_id, NOW(), NOW());
	COMMIT;
SET vintReturn = int_next_id;
SELECT vintReturn;
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS sp_update_parties;
DELIMITER $$
CREATE PROCEDURE sp_update_parties(
	in vint_party_id int(11),
	in vtxt_name varchar(100),
	in vtxt_short_name varchar(25),
	in vtxt_contact_person varchar(60),
	in vtxt_address varchar(200),
	in vtxt_city varchar(25),
	in vtxt_mobile varchar(25),
	in vtxt_mobile_whatsapp varchar(25),
	in vtxt_email varchar(100),
	in vtxt_gstn varchar(50),
	in vtxt_pan varchar(25),
	in vint_by_user_id int(11),
	out vintReturn INT)
BEGIN
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	START TRANSACTION;
	UPDATE tbl_parties set
		txt_name=vtxt_name, txt_short_name=vtxt_short_name, txt_contact_person=vtxt_contact_person, txt_address=vtxt_address, txt_city=vtxt_city, txt_mobile=vtxt_mobile, txt_mobile_whatsapp=vtxt_mobile_whatsapp, txt_email=vtxt_email, txt_gstn=vtxt_gstn, txt_pan=vtxt_pan, int_by_user_id=vint_by_user_id,  dat_modified= NOW()
	WHERE int_party_id=vint_party_id;
	COMMIT;
	SET vintReturn = vint_party_id;
	SELECT vintReturn;
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS sp_delete_parties;
DELIMITER $$
CREATE PROCEDURE sp_delete_parties(
	in vint_party_id INT,
	out vintReturn INT)
BEGIN
	DECLARE int_ref_count int;
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	START TRANSACTION;
		SELECT SUM(int_count) INTO int_ref_count FROM (
		(Select count(int_party_id) AS int_count FROM tbl_purchase_order WHERE int_party_id=vint_party_id)
		 UNION ALL
		(Select count(int_party_id) AS int_count FROM tbl_sales_order WHERE int_party_id=vint_party_id)
		 ) qry; 
		IF(int_ref_count> 0) THEN 
			SET vintReturn = 0;
		ELSE 
			DELETE FROM tbl_parties WHERE int_party_id=vint_party_id;
			SET vintReturn = vint_party_id;
		END IF;
	COMMIT;
	SELECT vintReturn;
END$$
DELIMITER ;
