//Call sp_insert_products_full('2021-12-20','DMO',' ', 200,1,@return);

//call sp_update_products_full(3,'2021-12-21','Limolene','12345',300,1,@return);
//Call sp_insert_stock_movement( '2021-12-20', 1, 200,1, @return ); 

DELIMITER $$
CREATE PROCEDURE sp_insert_products_full(
	in vdat_opening date,
	in vtxt_product_name varchar(100),
	in vtxt_hsn_code varchar(25),
	in vdec_quantity decimal(15,3),
	in vint_by_user_id int(11),
    out vintReturn INT)
BEGIN
	DECLARE int_next_product_id int;
	DECLARE int_next_opening_id int;
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	START TRANSACTION;
		Call sp_insert_products (vtxt_product_name, vtxt_hsn_code, vint_by_user_id, @return );
		SELECT @return INTO int_next_product_id ;
		
		IF vdec_quantity > 0 THEN
			Call  sp_insert_opening(vdat_opening, int_next_product_id, vdec_quantity, vint_by_user_id, @return);
			SELECT @return INTO int_next_opening_id ;
			
			Call sp_insert_stock_movement( vdat_opening, int_next_product_id, vdec_quantity, Null, Null, Null, Null, Null, int_next_opening_id, Null, Null, Null, Null, Null, 'Opening stock', vint_by_user_id, @return ); 
		END IF;             
  COMMIT;
  SET vintReturn = int_next_product_id;
	SELECT vintReturn;
END$$

DELIMITER $$
  CREATE PROCEDURE sp_update_products_full(
	in vint_product_id int(11),
    in vdat_opening date,
	in vtxt_product_name varchar(100),
	in vtxt_hsn_code varchar(25),
	in vdec_quantity decimal(15,3),
	in vint_by_user_id int(11),
    out vintReturn INT)
BEGIN 
	DECLARE uint_opening_id int;
	DECLARE uint_stock_movement_id int;
	DECLARE int_vstock_movement_id int;
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
    START TRANSACTION;
		
		Call sp_update_products(vint_product_id, vtxt_product_name, vtxt_hsn_code, vint_by_user_id, @return);
		
		SELECT int_opening_id INTO uint_opening_id FROM tbl_opening WHERE int_product_id = vint_product_id;
		
		IF uint_opening_id>0 THEN
			Call sp_update_opening(uint_opening_id, vdat_opening, vint_product_id, vdec_quantity, vint_by_user_id, @return);
			
			SELECT int_stock_movement_id INTO uint_stock_movement_id FROM tbl_stock_movement where int_target_opening_id = uint_opening_id;
			
			IF uint_stock_movement_id>0 THEN
				Call sp_update_stock_movement(uint_stock_movement_id, vdat_opening, vint_product_id, vdec_quantity, Null, Null, Null, Null, Null, uint_opening_id, Null, Null, Null, Null, Null, 'Opening stock', vint_by_user_id, @return);
			ELSE
				Call sp_insert_stock_movement( vdat_opening, vint_product_id, vdec_quantity, Null, Null, Null, Null, Null, uint_opening_id, Null, Null, Null, Null, Null, 'Opening stock', vint_by_user_id, @return ); 
			END IF;						
		ELSE
			Call  sp_insert_opening(vdat_opening, vint_product_id, vdec_quantity, vint_by_user_id, @return);
			SELECT @return INTO uint_opening_id ;
			
			Call sp_insert_stock_movement( vdat_opening, vint_product_id, vdec_quantity, Null, Null, Null, Null, Null, uint_opening_id, Null, Null, Null, Null, Null, 'Opening stock', vint_by_user_id, @return ); 
		END IF;      
  COMMIT;
  SET vintReturn = 1;
  SELECT vintReturn;
END$$
  