Call sp_insert_purchase_order_full('2021-12-22',1,2, Null, Null, 0, 1500, 300, 1200, 0, 0, 0, 'hi-try',1, @return);

DELIMITER $$
CREATE PROCEDURE sp_insert_purchase_order_full(
	in vdat_transaction date,
	in vint_party_id int(11),
	in vint_product_id int(11),
	in vint_agent_party_id int(11),
	in vtxt_party_document_no varchar(100),
	in vdec_rate decimal(15,2),
	in vdec_total_gross_weight decimal(15,3),
	in vdec_total_tare_weight decimal(15,3),
	in vdec_total_net_weight decimal(15,3),
	in vdec_total_product_value decimal(15,2),
	in vdec_total_freight_value decimal(15,2),
	in vdec_total_tax_value decimal(15,2),
	in vtxt_remarks varchar(250),
	in vint_by_user_id int(11),
    out vintReturn INT)
BEGIN
	DECLARE int_next_purchase_id int;
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	START TRANSACTION;
		Call sp_insert_purchase_order(vdat_transaction, vint_party_id, vint_product_id, vint_agent_party_id, vtxt_party_document_no, vdec_rate, vdec_total_gross_weight, vdec_total_tare_weight, vdec_total_net_weight, vdec_total_product_value, vdec_total_freight_value,  vdec_total_tax_value, vtxt_remarks, vint_by_user_id, @return );
		
		SELECT @return INTO int_next_purchase_id ;
			
		Call sp_insert_stock_movement( vdat_transaction, vint_product_id, vdec_total_net_weight, Null, Null, Null, Null, Null, Null, int_next_purchase_id, Null, Null, Null, Null, vtxt_remarks, vint_by_user_id, @return );           
	COMMIT;
	SET vintReturn = int_next_purchase_id;
	SELECT vintReturn;
END$$

//Call sp_update_purchase_order_full(1,'2021-12-21',2,'2022-23/2',1,2,Null,Null,0,2500,500,2000,0,0,0,'Update purchase',1,@return);
DELIMITER $$
  CREATE PROCEDURE sp_update_purchase_order_full(
	in vint_purchase_order_id int(11),
	in vdat_transaction date,
	in vint_number int(11),
	in vtxt_formatted_number varchar(25),
	in vint_party_id int(11),
	in vint_product_id int(11),
	in vint_agent_party_id int(11),
	in vtxt_party_document_no varchar(100),
	in vdec_rate decimal(15,2),
	in vdec_total_gross_weight decimal(15,3),
	in vdec_total_tare_weight decimal(15,3),
	in vdec_total_net_weight decimal(15,3),
	in vdec_total_product_value decimal(15,2),
	in vdec_total_freight_value decimal(15,2),
	in vdec_total_tax_value decimal(15,2),
	in vtxt_remarks varchar(250),
	in vint_by_user_id int(11),
    out vintReturn INT)
BEGIN 
	DECLARE uint_target_purchase_id int;
	DECLARE uint_stock_movement_id int;
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
    START TRANSACTION;
			Call sp_update_purchase_order(vint_purchase_order_id, vdat_transaction, vint_number, vtxt_formatted_number,
			vint_party_id, vint_product_id, vint_agent_party_id, vtxt_party_document_no, vdec_rate, vdec_total_gross_weight,
			vdec_total_tare_weight, vdec_total_net_weight, vdec_total_product_value, vdec_total_freight_value,
			vdec_total_tax_value, vtxt_remarks, vint_by_user_id, @return);
		
		SELECT int_stock_movement_id INTO uint_stock_movement_id 
			FROM tbl_stock_movement 
			where int_target_purchase_id = vint_purchase_order_id;
			
		IF uint_stock_movement_id> 0 THEN
			Call sp_update_stock_movement(uint_stock_movement_id, vdat_transaction, vint_product_id, vdec_total_net_weight, Null, Null, Null, Null, Null, Null, vint_purchase_order_id, Null, Null, Null, Null, vtxt_remarks, vint_by_user_id, @return);
		ELSE
			Call sp_insert_stock_movement( vdat_transaction, vint_product_id, vdec_total_net_weight, Null, Null, Null, Null, Null, Null, vint_purchase_order_id, Null, Null, Null, Null, vtxt_remarks, vint_by_user_id, @return ); 
		END IF;
  COMMIT;
  SET vintReturn = 1;
  SELECT vintReturn;
END$$
  