/*
call sp_purchase_report(0,0)
call sp_purchase_report(1,0)
call sp_purchase_report(0,0) 
*/

DROP PROCEDURE IF EXISTS sp_purchase_report;
DELIMITER $$
CREATE PROCEDURE sp_purchase_report(
	in vparty_id int,
	in vproduct_id int
	)
BEGIN
	IF vparty_id=0 And vproduct_id=0 THEN
		SELECT dat_transaction,txt_formatted_number as purchase_no,
			   product_name,
			   party_name,
			   dec_total_net_weight   as quantity
		FROM (vw_purchase_order)
		UNION ALL
        select  '' as dat_transaction,
		'' as purchase_no,'' as product_name, 
		'' as party_name,
		sum(dec_total_net_weight) as Total from vw_purchase_order;
		
	ELSEIF vparty_id>0 THEN
		SELECT dat_transaction,txt_formatted_number as purchase_no,
			   product_name,
			   party_name,
			   dec_total_net_weight   as quantity
		FROM (vw_purchase_order) where (int_party_id=vparty_id)
		UNION ALL
		select  '' as dat_transaction,
		'' as purchase_no,'' as product_name, 
		'' as party_name,
		sum(dec_total_net_weight) as Total from (vw_purchase_order) where (int_party_id=vparty_id);
	ELSEIF vproduct_id>0 THEN
		SELECT dat_transaction,txt_formatted_number as purchase_no,
			   product_name,
			   party_name,
			   dec_total_net_weight   as quantity
		FROM (vw_purchase_order) where (int_product_id=vproduct_id)
		UNION ALL
		select  '' as dat_transaction,
		'' as purchase_no,'' as product_name, 
		'' as party_name,
		sum(dec_total_net_weight) as Total from (vw_purchase_order) where (int_product_id=vproduct_id);
	ELSEIF vparty_id>0 And vproduct_id>0 THEN
		SELECT dat_transaction,txt_formatted_number as purchase_no,
			   product_name,
			   party_name,
			   dec_total_net_weight   as quantity
		FROM (vw_purchase_order) where ((int_product_id=vproduct_id) AND (int_party_id=vparty_id))
		UNION ALL
		select  '' as dat_transaction,
		'' as purchase_no,'' as product_name, 
		'' as party_name,
		sum(dec_total_net_weight) as Total from (vw_purchase_order) where ((int_product_id=vproduct_id) AND (int_party_id=vparty_id));
     END IF;
END$$
DELIMITER ;