DROP PROCEDURE IF EXISTS sp_insert_type;
DELIMITER $$
CREATE PROCEDURE sp_insert_type(
	in vint_category_id int(11),
	in vint_type int(11),
	in vtxt_name varchar(100),
	in vysn_fixed tinyint(1),
	out vintReturn INT)
BEGIN
	DECLARE int_next_id int;
	DECLARE int_fy int;
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	START TRANSACTION;
	SELECT (ifnull(MAX(int_type_id),0)+1) into int_next_id FROM tbl_type;
	INSERT INTO tbl_type(
	int_type_id, int_category_id, int_type, txt_name, ysn_fixed)
	 VALUES (
	int_next_id, vint_category_id, vint_type, vtxt_name, vysn_fixed);
	COMMIT;
SET vintReturn = int_next_id;
SELECT vintReturn;
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS sp_update_type;
DELIMITER $$
CREATE PROCEDURE sp_update_type(
	in vint_type_id int(11),
	in vint_category_id int(11),
	in vint_type int(11),
	in vtxt_name varchar(100),
	in vysn_fixed tinyint(1),
	out vintReturn INT)
BEGIN
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	START TRANSACTION;
	UPDATE tbl_type set
		int_category_id=vint_category_id, int_type=vint_type, txt_name=vtxt_name, ysn_fixed= vysn_fixed
	WHERE int_type_id=vint_type_id;
	COMMIT;
	SET vintReturn = vint_type_id;
	SELECT vintReturn;
END$$
DELIMITER ;

DROP PROCEDURE IF EXISTS sp_delete_type;
DELIMITER $$
CREATE PROCEDURE sp_delete_type(
	in vint_type_id INT,
	out vintReturn INT)
BEGIN
	DECLARE int_ref_count int;
	DECLARE EXIT HANDLER FOR SQLEXCEPTION
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	DECLARE EXIT HANDLER FOR SQLWARNING
	BEGIN
		SET vintReturn = 0;
		SHOW ERRORS;
		ROLLBACK;
	END;
	START TRANSACTION;
		DELETE FROM tbl_type WHERE int_type_id=vint_type_id;
		SET vintReturn = vint_type_id;
	COMMIT;
	SELECT vintReturn;
END$$
DELIMITER ;
